/*****************************************************************

Copyright (c) 2004 Abdiel Janulgue <xynopsis@yahoo.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software. 
******************************************************************/

#include <qlcdnumber.h>
#include <kglobal.h>
#include <klocale.h>
#include <kconfig.h>
#include <kapplication.h>
#include <kmessagebox.h>
#include <qfile.h>
#include <qpopupmenu.h>
#include <qcursor.h>

#include "kdex11client.h"
#include "x11lock.h"


kdex11client::kdex11client(const QString& configFile, Type type, int actions, QWidget *parent, const char *name)
    : KPanelApplet(configFile, type, actions, parent, name)
{
    // TODO: show remaining time here and other info
	setBackgroundColor( blue );
    	setFrameStyle( StyledPanel | Sunken );

   	w = new x11lock();
    	w->lockscreen();

    	QFile file( ".kioskdata" );
    	if(file.open( IO_ReadOnly ) ) {
		QDataStream stream( &file );  // read the data serialized from the file
		QString serialnum;
		int seconds_copy;
		stream >> serialnum >> seconds_copy;

		if(seconds_copy > 0) { // should be > 60
	    		qDebug("seconds_copy from file: %d", seconds_copy);
	    		w->netUpdate(serialnum, seconds_copy);
		}
		file.close();
    	}

    	pop = new QPopupMenu(this);
    	pop->insertItem("&Check Remaining Time", this,
		    SLOT( remainingCheck() ), CTRL+Key_C);
    	pop->insertItem("&Log Off", this,
		    SLOT( logOff() ), CTRL+Key_L);
}

kdex11client::~kdex11client()
{
	 delete w;
}

void kdex11client::mousePressEvent( QMouseEvent * e )
{
    if(e->button() == RightButton)
	pop->exec(QCursor::pos());
}

void kdex11client::remainingCheck()
{
    w->remainingCheck();
}

void kdex11client::logOff()
{
    w->lockUpdate();
}

int kdex11client::widthForHeight(int height) const
{
    return height;
}

int kdex11client::heightForWidth(int width) const
{
    return width;
}

extern "C"
{
    KPanelApplet* init( QWidget *parent, const QString configFile)
    {
        KGlobal::locale()->insertCatalogue("kdex11client");
        return new kdex11client(configFile, KPanelApplet::Normal,
				0, parent, "kdex11client");
    }
}
