/*****************************************************************

Copyright (c) 2004 Abdiel Janulgue <xynopsis@yahoo.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
******************************************************************/
#ifndef KDEX11CLIENT_H
#define KDEX11CLIENT_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kpanelapplet.h>
#include <qstring.h>
#include <kconfig.h>

class x11lock;
class QPopupMenu;

class kdex11client : public KPanelApplet
{
    Q_OBJECT

public:
    kdex11client(const QString& configFile, Type t = Normal, int actions = 0,
        QWidget *parent = 0, const char *name = 0);
    ~kdex11client();
    virtual int widthForHeight(int height) const;
    virtual int heightForWidth(int width) const;

protected:
    void mousePressEvent ( QMouseEvent * e );

private slots:
    void remainingCheck();
    void logOff();

private:
    x11lock* w;
    QPopupMenu* pop;
};

#endif
