/*****************************************************************

Copyright (c) 2004 Abdiel Janulgue <xynopsis@yahoo.com>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software. 
******************************************************************/
#ifndef X11LOCK_H
#define X11LOCK_H

#include <qvariant.h>
#include <qwidget.h>
#include <qtimer.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class QLabel;
class NetAccess;
class KioskLockP;

class x11lock : public QWidget
{
    Q_OBJECT;
    
public:
    x11lock( QWidget* parent = 0, const char* name = 0, 
	     WFlags fl =  WStyle_Customize | WStyle_NoBorder );
    ~x11lock();

protected:
    QHBoxLayout* x11lockLayout;
    void mouseReleaseEvent ( QMouseEvent * ) {  emit clicked(); }
    void keyReleaseEvent ( QKeyEvent * ) {  emit released(); }
    void showEvent ( QShowEvent * );
    void hideEvent ( QHideEvent * ); 
    virtual bool x11Event(XEvent *);

public slots:	
    void update();
    void lockscreen(); 
    void unlock(int);
    void netUpdate(const QString& , unsigned int);
    void remainingCheck();
    void lockUpdate();
    
private slots:

    void lock();
    void useraction();
    void countdown();
    void savestate();
  
protected slots:

    virtual void languageChange();
signals: 

    void clicked();
    void released();
 
private:
    bool grabKeyboard();
    bool grabMouse();
    bool grabInput();
    void ungrabInput();
    void createWindow();
    void screenTimerLock();
    
    bool isDialogUp;
    NetAccess* getserial;
    KioskLockP* klp;
    QString serialnum; 
    unsigned int seconds_copy;
    QLabel* kioskimage;
    QTimer* savetm;
    QTimer* cdowntm;
    QTimer xtimer;
};

#endif // X11LOCK_H
